import numpy as np
import matplotlib.pyplot as plt
from qiskit import QuantumCircuit, transpile
from qiskit.providers.aer import QasmSimulator
from qiskit.visualization import plot_histogram

# Use Aer's qasm_simulator
simulator = QasmSimulator()

# Pre- and post-processing for Deutsch's algorithm^

# Implement the pre-processing here
pre = QuantumCircuit(2)
#pre.somegate(0)

pre.barrier() # Used here for nicer circuit draw 

# Implement the post-processing here
post = QuantumCircuit(2)
post.barrier() # Used here for nicer circuit draw
#post.somegate(0)


# Implement the oracles here and comment/uncomment as needed
oracle = QuantumCircuit(2)

# Constant 0
#

# Constant 1
oracle.x(1) 

# Identity
# 

# Negate
#
#

circuit = QuantumCircuit(2)
circuit.compose(pre, inplace=True)
circuit.compose(oracle, inplace=True)
circuit.compose(post, inplace=True)

# Map the quantum measurement to the classical bits
circuit.measure_all()

# Draw the circuit
print(circuit.draw())
#circuit.draw(output='mpl')

# compile the circuit down to low-level QASM instructions
# supported by the backend (not needed for simple circuits)
compiled_circuit = transpile(circuit, simulator)

# Execute the circuit on the qasm simulator
job = simulator.run(compiled_circuit)

# Grab results from the job
result = job.result()
counts=result.get_counts(compiled_circuit)

# Plot a histogram
plot_histogram(counts)
plt.show()
